#define  NC      2
#define  NCOL    2

//====================================================================
namespace {

  void check_Nc(){

    vout.paranoiac(CommonParameters::Vlevel(),
                 "Field_G: implementation for SU(2).\n");

  }

  double mult_Gnn_r(double* g1, double* g2, int Nc){

    return   g1[0]*g2[0] - g1[1]*g2[1]
           + g1[2]*g2[4] - g1[3]*g2[5];

  }

  double mult_Gnn_i(double* g1, double* g2, int Nc){

    return    g1[0]*g2[1] + g1[1]*g2[0]
            + g1[2]*g2[5] + g1[3]*g2[4];

  }

  double mult_Gdn_r(double* g1, double* g2, int Nc){

    return   g1[0]*g2[0] + g1[1]*g2[1]
           + g1[4]*g2[4] + g1[5]*g2[5];

  }

  double mult_Gdn_i(double* g1, double* g2, int Nc){

    return    g1[0]*g2[1] - g1[1]*g2[0]
            + g1[4]*g2[5] - g1[5]*g2[4];

  }

  double mult_Gnd_r(double* g1, double* g2, int Nc){

    return   g1[0]*g2[0] + g1[1]*g2[1]
           + g1[2]*g2[2] + g1[3]*g2[3];

  }

  double mult_Gnd_i(double* g1, double* g2, int Nc){

    return - g1[0]*g2[1] + g1[1]*g2[0]
           - g1[2]*g2[3] + g1[3]*g2[2];

  }

  double mult_Gdd_r(double* g1, double* g2, int Nc){

    return   g1[0]*g2[0] - g1[1]*g2[1]
           + g1[4]*g2[2] - g1[5]*g2[3];

  }

  double mult_Gdd_i(double* g1, double* g2, int Nc){

    return - g1[0]*g2[1] - g1[1]*g2[0]
           - g1[4]*g2[3] - g1[5]*g2[2];

  }

} // end of nameless namespace
//====================================================================
//============================================================END=====
