/*!
        @file    $Id: fieldIO_Text_4x4x4x8.h 1145 2014-09-16 09:27:22Z namekawa $
        @brief
        @author  $LastChangedBy: namekawa $
        @date    $LastChangedDate: 2014-09-16 18:27:22 +0900 (火, 16  9月 2014) $
        @version $LastChangedRevision: 1145 $
*/


#ifndef FIELDIO_TEXT_4x4x4x8_INCLUDED
#define FIELDIO_TEXT_4x4x4x8_INCLUDED

#include <string>
using std::string;

#include "fieldIO.h"
#include "index_lex.h"
#include "field.h"

//! FieldIO_Text class for file I/O of Field data in plain text format.

/*!
   This class read 4x4x4x8 in plain text format lattice and
   periodically copy it as a larger size of lattice.
   The configuration is read on the rank 0 node and broadcasted.
   No write method is defined.
                                         [11 Jul 2014 H.Matsufuru]
*/

class FieldIO_Text_4x4x4x8 : public FieldIO
{
 public:
  static const std::string class_name;

 public:
  FieldIO_Text_4x4x4x8(const IO_Format::Format *format) : FieldIO(format)
  {
//    d_prefix  = "conf_";
//    d_postfix = ".txt";
  }

  void read_file(Field *v, string filename);
  void write_file(Field *v, string filename);
};
#endif
