/*
        @file    $Id: run_test.cpp #$

        @brief

        @author  Tatsumi Aoyama <aoym@post.kek.jp> (aoym)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate: 2013-04-08 18:00:27 #$

        @version $LastChangedRevision: 1144 $
*/

#include "main.h"
#include "testlist.h"

//====================================================================
int run_test()
{
#if defined(USE_GROUP_SU2)
  // Nc=2 is not available.
#else
  Test_Eigensolver::solve();
  Test_Eigensolver::solve_chebyshev();
  Test_Eigensolver::solve_SF();

  Test_Gauge::plaquette();
  Test_Gauge::shift();

  Test_GradientFlow::update();

  Test_HMC_Clover::leapfrog_Nf2();
  Test_HMC_Clover::RHMC_Nf2p1();

  Test_HMC_Clover_Isochemical::leapfrog_Nf2();
  Test_HMC_Clover_Isochemical::RHMC_Nf2p1();

  Test_HMC_Clover_SF::leapfrog_Nf2();
  Test_HMC_Clover_SF::RHMC_Nf2p1();

  Test_HMC_Wilson::leapfrog_Nf2();

  Test_HotStart::determinant();
  Test_HotStart::eigenvalue();
  Test_HotStart::unitary();

  Test_IO_Data::test_io_data_text();

  Test_IO_GaugeConfig::test_io_gconf_text();
  Test_IO_GaugeConfig::test_io_gconf_binary();
  Test_IO_GaugeConfig::test_io_gconf_fortran();
  Test_IO_GaugeConfig::test_io_gconf_binary_parallel();
#ifdef USE_LIMELIB
  Test_IO_GaugeConfig::test_io_gconf_ILDG();
  Test_IO_GaugeConfig::test_io_gconf_ILDG_parallel();
#endif

  Test_Mult_Wilson::mult();

  Test_PolyakovLoop::polyakovloop();

  Test_QuarkNumSuscept::quark_num_suscept();
#endif

  Test_RandomNumbers_Mseries::uniform_calc_pi();
  Test_RandomNumbers_Mseries::gaussian();
  Test_RandomNumbers_Mseries::gaussian_field();
  Test_RandomNumbers_Mseries::test_global();

  Test_RandomNumbers_MT19937::uniform_calc_pi();
  Test_RandomNumbers_MT19937::gaussian_field();
  Test_RandomNumbers_MT19937::test_global();

#ifdef USE_SFMTLIB
  Test_RandomNumbers_SFMT::uniform_calc_pi();
  Test_RandomNumbers_SFMT::gaussian_field();
  Test_RandomNumbers_SFMT::test_global();
#endif

#if defined(USE_GROUP_SU2)
  // Nc=2 is not available.
#else
  Test_Rational::approx();
  Test_Rational::inverse();
  Test_Rational::smeared_rational();

#if defined(USE_OPENMP)
  // multithreading yet unsupported.
#else
  Test_SF_fAfP::boundary_meson_2ptFunction();
#endif

  Test_ShiftSolver::solve();

  Test_Spectrum_Clover::hadron_2ptFunction();
  Test_Spectrum_Clover::hadron_2ptFunction_eo();
  Test_Spectrum_Clover::hadron_2ptFunction_withFileIO();
  Test_Spectrum_Clover::hadron_2ptFunction_eo_withFileIO();

  Test_Spectrum_Wilson::hadron_2ptFunction();
  Test_Spectrum_Wilson::hadron_2ptFunction_eo();

#ifdef USE_MPI
  // these tests run only in single-node environment.
#else
  //- NB. CRS tests are skipped, because they are time-consuming.
  // Test_Spectrum_CRSMatrix::clover_lex();
  // Test_Spectrum_CRSMatrix::domainwall();
  // Test_Spectrum_CRSMatrix::overlap_5d();
#endif

  Test_TopologicalCharge::topological_charge();

  Test_WilsonLoop::wilsonloop();
#endif

  return 0;
}
