/*
        @file    $Id: run_testmanager.cpp #$

        @brief

        @author
                 $LastChangedBy: aoym $

        @date    $LastChangedDate: 2013-04-12 13:28:01 #$

        @version $LastChangedRevision: 1144 $
*/

#include "main.h"
#include "test.h"
#include "testlist.h"
#include "testManager.h"

//====================================================================
int run_testmanager(int argc, char **argv)
{
  TestManager& testmanager = TestManager::Instance();  // find singleton

#ifdef USE_TESTMANAGER_AUTOREGISTER
  //- tests are registered automatically at start up.

#else
  //- register tests manually:
  //
  // testmanager.registerTest(
  //   "Gauge.Plaquette",
  //   Test_Gauge::plaquette
  // );
#endif

  if (argc > 1) {
    if (string(argv[1]) == "-a") {  // run all tests
      testmanager.batch_recursive();
    } else {
      // argv[] = { "./bridge.elf", test1, (test2, ...) }
      testmanager.batch_recursive(argc - 1, argv + 1);
    }
  } else {
    testmanager.interactive();
  }

  return 0;
}
