/*!
        @file    $Id:: fprop.h #$

        @brief

        @author  Satoru Ueda <sueda@post.kek.jp> (sueda)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2014-06-06 20:58:05 #$

        @version $LastChangedRevision: 1067 $
*/

#ifndef FPROP_INCLUDED
#define FPROP_INCLUDED

#include "fopr.h"
#include "bridgeIO.h"

class Fprop
{
 protected:
  Bridge::VerboseLevel m_vl;

 public:

  Fprop()
    : m_vl(CommonParameters::Vlevel()) {}

  virtual ~Fprop() {}

  void set_parameter_verboselevel(const Bridge::VerboseLevel vl) { m_vl = vl; }

  virtual void invert_D(Field&, const Field&, int&, double&)     = 0;
  virtual void invert_DdagD(Field&, const Field&, int&, double&) = 0;

  virtual void set_config(Field *) = 0;
};
#endif
