/*!
        @file    $Id:: noiseVector_Z2.h #$

        @brief

        @author  <Hideo Matsufuru> hideo.matsufuru@kek.jp(matsufuru)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2014-04-12 16:31:14 #$

        @version $LastChangedRevision: 1031 $
*/

#ifndef NOISEVECTOR_Z2_INCLUDED
#define NOISEVECTOR_Z2_INCLUDED

#include "noiseVector.h"
#include "randomNumbers.h"

//! Z2 Noise vector for trance calculation.

/*!
    Z2 Noise vector.
                                     [30 Aug 2012 H.Matsufuru]
 */

class NoiseVector_Z2 : public NoiseVector
{
 public:
  static const std::string class_name;

 private:
  RandomNumbers *m_rand;

 public:

  NoiseVector_Z2(RandomNumbers *rand)
    : NoiseVector(), m_rand(rand) {}

  void set(Field& v);
};
#endif
