/*!
        @file    $Id: solver_CGNE.h #$

        @brief

        @author  Tatsumi Aoyama <aoym@post.kek.jp> (aoym)
                 $LastChangedBy: matufuru $

        @date    $LastChangedDate: 2013-03-21 15:28:34 #$

        @version $LastChangedRevision: 1119 $
*/

#ifndef SOLVER_CGNE_INCLUDED
#define SOLVER_CGNE_INCLUDED

#include "solver_CG.h"

//- parameters class
class Parameters_Solver_CGNE : virtual public Parameters
{
 public:
  Parameters_Solver_CGNE();
};
//- end

//! CGNE solver.

/*!
  solve D x = b
  by
  (D Ddag) y = b  and  x = Ddag y.

  delegate to base CG solver.
 */

class Solver_CGNE : public Solver_CG
{
 private:
  Field m_y;

 public:
  static const std::string class_name;

  Solver_CGNE(Fopr *fopr)
    : Solver_CG(fopr) {}

  ~Solver_CGNE() {}

  void set_parameters(const Parameters& params);

  void solve(Field& solution, const Field& source, int& Nconv, double& diff);

  Fopr *get_fopr() { return this->Solver_CG::get_fopr(); }

 private:
};
#endif
