/*!
        @file    $Id: solver_CGNR.h #$

        @brief

        @author  Tatsumi Aoyama <aoym@post.kek.jp> (aoym)
                 $LastChangedBy: matufuru $

        @date    $LastChangedDate: 2014-09-04 15:05:34 +0900 (木, 04  9月 2014) $

        @version $LastChangedRevision: 1119 $
*/

#ifndef SOLVER_CGNR_INCLUDED
#define SOLVER_CGNR_INCLUDED

#include "solver_CG.h"

//- parameters class
class Parameters_Solver_CGNR : virtual public Parameters
{
 public:
  Parameters_Solver_CGNR();
};
//- end

//! CGNR solver.

/*!
  solve D x = b
  by
  (Ddag D) x = b'  and  b' = Ddag b.

  delegate to base CG solver.
 */

class Solver_CGNR : public Solver_CG
{
 private:
  Field m_b2;

 public:
  static const std::string class_name;

  Solver_CGNR(Fopr *fopr)
    : Solver_CG(fopr) {}

  ~Solver_CGNR() {}

  void set_parameters(const Parameters& params);

  void solve(Field& solution, const Field& source, int& Nconv, double& diff);

  Fopr *get_fopr() { return this->Solver_CG::get_fopr(); }

 private:
};
#endif
