/*!
        @file    $Id:: randomNumbers_SFMT.h 114#$

        @brief

        @author  T.Aoyama <aoym@post.kek.jp> (aoym)
                 $LastChangedBy: namekawa $

        @date    $LastChangedDate:: 2014-09-16 18:27:22 #$

        @version $LastChangedRevision: 1145 $
*/

#ifndef RANDOMNUMBERS_SFMT_INCLUDED
#define RANDOMNUMBERS_SFMT_INCLUDED

#ifdef USE_SFMTLIB

// #define __STDC_CONSTANT_MACROS

#include <string>
#include <cassert>
#include "randomNumbers.h"
#include <SFMT.h>

#ifdef HAVE_NTL
#define ENABLE_SFMT_JUMP
#include <SFMT-jump-alt.h>
#endif

#include "bridgeIO.h"
using Bridge::vout;

class RandomNumbers_SFMT : public RandomNumbers
{
  static const std::string class_name;

 public:
  RandomNumbers_SFMT(const int s);
  RandomNumbers_SFMT(const std::string& filename) { readfile(filename); }

  ~RandomNumbers_SFMT() {}

  double get();
  void get_block(double *v, const size_t n);

  void writefile(const std::string& filename);
  void readfile(const std::string& filename);

#ifdef ENABLE_SFMT_JUMP
  virtual void uniform_lex_global(Field&);
  virtual void gauss_lex_global(Field&);

#endif

 private:

  template<typename T>
  void generate_global_jump(Field& f);

  sfmt_t m_state;
};

#endif /* USE_SFMTLIB */

#endif /* RANDOMNUMBERS_SFMT_INCLUDED */
